apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Scans Container images
  name: scan-image-gitleaks-jenkins-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        def podLabel = "gitleaks-${UUID.randomUUID().toString()}"
        pipeline {
            agent {
                kubernetes {
                    cloud 'openshift'
                    label podLabel
                    containerTemplate {
                        name 'jnlp'
                        image "{{ (opsimages | json_query("[?name=='jkaggitleaks'].image"))[0] }}"
                    }
                    inheritFrom 'base'
                    serviceAccount '{{ jenkins_name }}'
                }
            }
            options { timeout(time: 65, unit: 'MINUTES') }
            parameters {
                string(defaultValue: 'https://github.com/faust64/ase', description: 'Git Repository to Scan', name: 'gitRepo')
            }
            stages {
                stage('scan image') {
                    steps {
                        script {
                            openshift.withCluster() {
                                openshift.withProject() {
                                    try {
                                        currentBuild.description = "[SCANNING] ${params.gitRepo}"
                                        timeout(60) {
                                            sh """
                                            echo Using GitLeaks: `gitleaks version`;
                                            echo "==== Scanning ${params.gitRepo} ===="
                                            if ! gitleaks detect --source "${params.gitRepo}" --redact --report-path ./scan-output --report-format json;
                                                echo "==== Returned \$? ===="
                                            fi
                                            if ! test -s scan-output; then
                                                echo "==== Failed scanning repository ===="
                                                rm scan-output
                                                exit 1
                                            fi
                                            """
                                            def WARNING_COUNT = sh (
                                                    script: "wc -l scan-output",
                                                    returnStdout: true
                                                ).trim()
                                            sh "rm -f scan-output"
                                            def score = "UNKNOWN"
                                            if (WARNING_COUNT != "0") { score = "WARNING" }
                                            else { score = "OK" }
                                            def notifyMsg = """
                                            [${score}] ${params.gitRepo}
                                            warning: ${WARNING_COUNT}
                                            """.stripIndent()
                                            currentBuild.description = notifyMsg
                                            echo "${notifyMsg}"
                                            def notifyPost = notifyMsg.replaceAll('"', "'")
                                            echo "${notifyMsg}"
                                            try {
                                                withCredentials([string(credentialsId: "jenkins-notify-slack", variable: 'POST_URI')]) {
                                                    def postSlackData = "{ \"text\": \"${notifyPost}\" }"
                                                    try { sh "curl -s --data-urlencode 'payload=$postSlackData' 'https://hooks.slack.com/services/${POST_URI}'" }
                                                    catch(e) { echo "In catch block notifying slack - ${e}" }
                                                }
                                            } catch(e) { echo "Did not find slack credentials - would not notify" }
                                        }
                                    } catch(e) {
                                        echo "In catch scanning image - ${e}"
                                        throw e
                                    }
                                }
                            }
                        }
                    }
                }
            }
            post {
                always { echo "Done scanning ${params.gitRepo}" }
                changed { echo "changed?" }
                failure { echo "Build failed (${params.jobRetryCount} out of ${params.jobMaxRetry})" }
                success { echo "success!" }
                unstable { echo "unstable?" }
            }
        }
    type: JenkinsPipeline
